#include "stc8g.h"
#include "intrins.h"
#include "stdio.h"

#define FOSC        11059200UL
#define BAUD        (65536 - FOSC/4/115200)

int *BGV;

int ADCRead()
{
    int res;

    ADC_CONTR |= 0x40;                          //ADת
    _nop_();
    _nop_();
    while (!(ADC_CONTR & 0x20));                //ѯADCɱ־
    ADC_CONTR &= ~0x20;                         //ɱ־
    res = (ADC_RES << 8) | ADC_RESL;            //ȡADC

    return res;
}

int VBACCount(void)
{
    int res;
    int vcc;
    int i;

    ADCRead();
    ADCRead();                                  //ǰݽ鶪

    res = 0;
    for (i=0; i<8; i++)
    {
        res += ADCRead();                       //ȡ8
    }
    res >>= 3;                                  //ȡƽֵ

    vcc = (int)(1024L * *BGV / res);            //(10λADC㷨)VREFܽŵѹ,صѹ

    return vcc;
}

void Delay100ms(void)	//@11.0592MHz
{
	unsigned char data i, j, k;

	_nop_();
	i = 6;
	j = 157;
	k = 59;
	do
	{
		do
		{
			while (--k);
		} while (--j);
	} while (--i);
}

void main()
{
    P_SW2 = 0x80;
    P0M0 = 0x00; P0M1 = 0x00;
    P1M0 = 0x00; P1M1 = 0x00;
    P2M0 = 0x00; P2M1 = 0x00;
    P3M0 = 0x00; P3M1 = 0x00;
    P5M0 = 0x00; P5M1 = 0x00;
    
    ADCTIM = 0x3f;                              //ADCڲʱ
    ADCCFG = 0x2f;                              //ADCʱΪϵͳʱ/2/16
    ADC_CONTR = 0x8f;                           //ʹADCģ,ѡ15ͨ
    
    AUXR = 0x40;
    TMOD = 0x00;
    TL1 = BAUD;
    TH1 = BAUD >> 8;
    TR1 = 1;
    SCON = 0x52;
    
    BGV = (int idata *)0xef;
   
    printf("BGV to VCC test !\n");
    
    while (1)
    {
        printf("%d\n", VBACCount());
        Delay100ms();
    }
}
